<template lang="pug">
  i(:class="className")
    svg(xmlns="http://www.w3.org/2000/svg")
      title(v-if="title") {{ title }}
      use(:xlink:href="iconPath" xmlns:xlink="http://www.w3.org/1999/xlink")
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'

@Component({
  props: {
    name: {
      type: String,
      required: true
    },

    title: {
      type: String,
      default: null
    }
  }
})
export default class GPMIcon extends Vue {
  // Props
  readonly name!: string
  readonly title!: string

  // Computed
  get iconPath (): string {
    let icon = require(`@/assets/icons/${this.name}.svg`)
    if (Object.prototype.hasOwnProperty.call(icon, 'default')) {
      icon = icon.default
    }

    return icon.url
  }

  get className (): string {
    return `gpm-icon gpm-icon--${this.name}`
  }
}
</script>

<style lang="scss">
.gpm-icon {
  display: inline-block;
  font-size: 0;
  line-height: 0;
  vertical-align: middle;
}
</style>
